<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Compartment ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Compartment extends AbstractStructArrayBase
{
    /**
     * The Compartment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Compartment[]
     */
    public $Compartment;
    /**
     * Constructor method for ArrayOfJP_Compartment
     * @uses ArrayOfJP_Compartment::setCompartment()
     * @param \StructType\JP_Compartment[] $compartment
     */
    public function __construct(array $compartment = array())
    {
        $this
            ->setCompartment($compartment);
    }
    /**
     * Get Compartment value
     * @return \StructType\JP_Compartment[]|null
     */
    public function getCompartment()
    {
        return $this->Compartment;
    }
    /**
     * Set Compartment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Compartment[] $compartment
     * @return \ArrayType\ArrayOfJP_Compartment
     */
    public function setCompartment(array $compartment = array())
    {
        foreach ($compartment as $arrayOfJP_CompartmentCompartmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CompartmentCompartmentItem instanceof \StructType\JP_Compartment) {
                throw new \InvalidArgumentException(sprintf('The Compartment property can only contain items of \StructType\JP_Compartment, "%s" given', is_object($arrayOfJP_CompartmentCompartmentItem) ? get_class($arrayOfJP_CompartmentCompartmentItem) : gettype($arrayOfJP_CompartmentCompartmentItem)), __LINE__);
            }
        }
        $this->Compartment = $compartment;
        return $this;
    }
    /**
     * Add item to Compartment value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Compartment $item
     * @return \ArrayType\ArrayOfJP_Compartment
     */
    public function addToCompartment(\StructType\JP_Compartment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Compartment) {
            throw new \InvalidArgumentException(sprintf('The Compartment property can only contain items of \StructType\JP_Compartment, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Compartment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Compartment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Compartment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Compartment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Compartment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Compartment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Compartment
     */
    public function getAttributeName()
    {
        return 'Compartment';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Compartment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
